<div
  class="sub-page-container"
  *ngIf="optimization | async; let optimizationValue"
>
  <!-- Title -->
  <h1>{{ 'parameter.optimization.title' | translate }}</h1>
  <mat-divider></mat-divider>
  <div class="sub-page-body" *ngIf="$schema | async; let schema">
    <div class="left-container">
      <div class="grid">
        <ng-container *ngIf="combinatorial.checked">
          <!-- 
            Pattern Combinations Per Parameter 
          -->
          <div class="grid-item patter-combinations-per-parameter">
            <div class="title">
              <h2>
                {{
                  'parameter.optimization.patternCombinationsPerParameter'
                    | translate
                }}
              </h2>
              <!-- <mat-icon
                [matTooltip]="
                  schema.optimization.properties.multi_step?.properties.pattern_combinations_per_parameter?.description
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon> -->
            </div>
            <energy-platform-parameter-slider
              #patternCombinationsPerParameter
              [min]="
                schema.optimization.properties.multi_step.properties
                  .pattern_combinations_per_parameter.minimum
              "
              [max]="
                schema.optimization.properties.multi_step.properties
                  .pattern_combinations_per_parameter.maximum
              "
              [step]="
                schema.optimization.properties.multi_step.properties
                  .pattern_combinations_per_parameter.step
              "
              [unit]="
                schema.optimization.properties.multi_step.properties
                  .pattern_combinations_per_parameter.unit
              "
              [value]="
                optimizationValue.multi_step.pattern_combinations_per_parameter
              "
              (valueChange)="
                optimizationValue.multi_step.pattern_combinations_per_parameter =
                  $event
              "
            ></energy-platform-parameter-slider>
          </div>
          <!-- 
            Turbines Number 
          -->
          <div class="grid-item turbines-number">
            <div class="title">
              <h2>{{ 'parameter.optimization.numTurbines' | translate }}</h2>
              <!-- <mat-icon
                [matTooltip]="
                  schema.optimization.properties.multi_step.properties.num_turbines?.description
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon> -->
            </div>
            <energy-platform-parameter-slider
              #numTurbines
              [min]="
                schema.optimization.properties.multi_step.properties
                  .num_turbines.minimum
              "
              [step]="
                schema.optimization.properties.multi_step.properties
                  .num_turbines.step
              "
              [unit]="
                schema.optimization.properties.multi_step.properties
                  .num_turbines.unit
              "
              [value]="optimizationValue.multi_step.num_turbines"
              (valueChange)="optimizationValue.multi_step.num_turbines = $event"
            ></energy-platform-parameter-slider>
          </div>

          <ng-container *ngIf="closePacking.checked">
            <div class="grid-item sub-header">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.closePacking' | translate }}
                </h2>
              </div>
            </div>
            <!-- 
              Matrix Simulations per Side 
            -->
            <div class="grid-item matrix-simulations-per-size">
              <div class="title">
                <h2>
                  {{
                    'parameter.optimization.matrixSimulationsPerSide'
                      | translate
                  }}
                </h2>
                <!-- <mat-icon
                  [matTooltip]="
                    schema.optimization.properties.close_packing?.properties.matrix_simulations_per_side.description
                  "
                  matTooltipPosition="right"
                >
                info_outlined 
                </mat-icon> -->
              </div>
              <energy-platform-parameter-slider
                #matrixSimulationsPerSide
                [min]="
                  schema.optimization.properties.close_packing.properties
                    .matrix_simulations_per_side.minimum
                "
                [max]="
                  schema.optimization.properties.close_packing.properties
                    .matrix_simulations_per_side.maximum
                "
                [step]="
                  schema.optimization.properties.close_packing.properties
                    .matrix_simulations_per_side.step
                "
                [unit]="
                  schema.optimization.properties.close_packing.properties
                    .matrix_simulations_per_side.unit
                "
                [value]="
                  optimizationValue.close_packing.matrix_simulations_per_side
                "
                (valueChange)="
                  optimizationValue.close_packing.matrix_simulations_per_side =
                    $event
                "
              ></energy-platform-parameter-slider>
            </div>
            <!-- 
              Threshold Range 
            -->
            <div class="grid-item threshold-range">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.thresholdRange' | translate }}
                </h2>
                <!-- <mat-icon
                  [matTooltip]="
                    schema.optimization.properties.close_packing?.properties?.threshold_range?.description
                  "
                  matTooltipPosition="right"
                >
                  info_outlined
                </mat-icon> -->
              </div>
              <energy-platform-ranged-slider
                *ngIf="schema.optimization"
                #thresholdRange
                [min]="
                  schema.optimization.properties.close_packing.properties
                    .threshold_range.items.minimum
                "
                [max]="
                  schema.optimization.properties.close_packing.properties
                    .threshold_range.items.maximum
                "
                unit="kW"
              ></energy-platform-ranged-slider>
            </div>
            <!-- 
              Interpolated Positions Per Side 
            -->
            <div class="grid-item interpolated-positions-per-side">
              <div class="title">
                <h2>
                  {{
                    'parameter.optimization.interpolatedPositionsPerSide'
                      | translate
                  }}
                </h2>
                <!-- <mat-icon
                  [matTooltip]="
                    schema.optimization.properties.close_packing?.properties.interpolated_positions_per_side.description
                  "
                  matTooltipPosition="right"
                >
                  info_outlined
                </mat-icon> -->
              </div>
              <energy-platform-parameter-slider
                #interpolatedPositionsPerSide
                [min]="
                  schema.optimization.properties.close_packing.properties
                    .interpolated_positions_per_side.minimum
                "
                [max]="
                  schema.optimization.properties.close_packing.properties
                    .interpolated_positions_per_side.maximum
                "
                [step]="
                  schema.optimization.properties.close_packing.properties
                    .interpolated_positions_per_side.step
                "
                [unit]="
                  schema.optimization.properties.close_packing.properties
                    .interpolated_positions_per_side.unit
                "
                [value]="
                  optimizationValue.close_packing
                    .interpolated_positions_per_side
                "
                (valueChange)="
                  optimizationValue.close_packing.interpolated_positions_per_side =
                    $event
                "
              ></energy-platform-parameter-slider>
            </div>
            <!-- 
              Threshold Steps 
            -->
            <div class="grid-item threshold-steps">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.thresholdSteps' | translate }}
                </h2>
                <!-- <mat-icon
                  [matTooltip]="
                    schema.optimization.properties.close_packing?.properties?.number_threshold_steps?.description
                  "
                  matTooltipPosition="right"
                >
                  info_outlined
                </mat-icon> -->
              </div>
              <energy-platform-parameter-slider
                #thresholdSteps
                [min]="
                  schema.optimization.properties.close_packing.properties
                    .number_threshold_steps.minimum
                "
                [max]="
                  schema.optimization.properties.close_packing.properties
                    .number_threshold_steps.maximum
                "
                [step]="
                  schema.optimization.properties.close_packing.properties
                    .number_threshold_steps.step
                "
                [unit]="
                  schema.optimization.properties.close_packing.properties
                    .number_threshold_steps.unit
                "
                [value]="optimizationValue.close_packing.number_threshold_steps"
                (valueChange)="
                  optimizationValue.close_packing.number_threshold_steps =
                    $event
                "
              ></energy-platform-parameter-slider>
            </div>
          </ng-container>

          <ng-container *ngIf="hexagonalGrid.checked">
            <div class="grid-item sub-header">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.hexagonalGrid' | translate }}
                </h2>
              </div>
            </div>
            <!-- 
                Rotation Angle Interval 
              -->
            <div class="grid-item rotation-angle-interval">
              <div class="title">
                <h2>
                  {{
                    'parameter.optimization.rotationAngleInterval' | translate
                  }}
                </h2>
                <!-- <mat-icon
                  [matTooltip]="
                    schema.optimization.properties.hexagonal_grid?.properties?.rotation_angle_interval?.description
                  "
                  matTooltipPosition="right"
                >
                  info_outlined
                </mat-icon> -->
              </div>
              <energy-platform-ranged-slider
                *ngIf="schema.optimization"
                #rotationAngleInterval
                [min]="
                  schema.optimization.properties.hexagonal_grid.properties
                    .rotation_angle_interval.items.minimum
                "
                [max]="
                  schema.optimization.properties.hexagonal_grid.properties
                    .rotation_angle_interval.items.maximum
                "
                [step]="
                  schema.optimization.properties.hexagonal_grid.properties
                    .rotation_angle_interval.items.step
                "
                [unit]="
                  schema.optimization.properties.hexagonal_grid.properties
                    .rotation_angle_interval.items.unit
                "
                (minValueChange)="
                  optimizationValue.hexagonal_grid.rotation_angle_interval[0] =
                    $event
                "
                (maxValueChange)="
                  optimizationValue.hexagonal_grid.rotation_angle_interval[1] =
                    $event
                "
              ></energy-platform-ranged-slider>
            </div>
            <!-- 
              Hexagon Side Interval 
            -->
            <div class="grid-item hexagon-side-interval">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.hexagonSideInterval' | translate }}
                </h2>
                <!-- <mat-icon
                  [matTooltip]="
                    schema.optimization.properties.hexagonal_grid?.properties?.hexagon_side_interval?.description
                  "
                  matTooltipPosition="right"
                >
                  info_outlined
                </mat-icon> -->
              </div>
              <energy-platform-ranged-slider
                *ngIf="schema.optimization"
                #hexagonSideInterval
                [min]="
                  schema.optimization.properties.hexagonal_grid.properties
                    .hexagon_side_interval.items.minimum
                "
                [max]="
                  schema.optimization.properties.hexagonal_grid.properties
                    .hexagon_side_interval.items.maximum
                "
                [step]="
                  schema.optimization.properties.hexagonal_grid.properties
                    .hexagon_side_interval.items.step
                "
                [unit]="
                  schema.optimization.properties.hexagonal_grid.properties
                    .hexagon_side_interval.items.unit
                "
                (minValueChange)="
                  optimizationValue.hexagonal_grid.hexagon_side_interval[0] =
                    $event
                "
                (maxValueChange)="
                  optimizationValue.hexagonal_grid.hexagon_side_interval[1] =
                    $event
                "
              ></energy-platform-ranged-slider>
            </div>
            <!-- 
              Vertical Stretch Interval 
            -->
            <div class="grid-item vertical-stretch-interval">
              <div class="title">
                <h2>
                  {{
                    'parameter.optimization.verticalStretchInterval' | translate
                  }}
                </h2>
                <!-- <mat-icon
                  [matTooltip]="
                    schema.optimization.properties.hexagonal_grid?.properties?.vertical_stretch_interval?.description
                  "
                  matTooltipPosition="right"
                >
                  info_outlined
                </mat-icon> -->
              </div>
              <energy-platform-ranged-slider
                *ngIf="schema.optimization"
                #verticalStretchInterval
                [min]="
                  schema.optimization.properties.hexagonal_grid.properties
                    .vertical_stretch_interval.items.minimum
                "
                [max]="
                  schema.optimization.properties.hexagonal_grid.properties
                    .vertical_stretch_interval.items.maximum
                "
                [step]="
                  schema.optimization.properties.hexagonal_grid.properties
                    .vertical_stretch_interval.items.step
                "
                [unit]="
                  schema.optimization.properties.hexagonal_grid.properties
                    .vertical_stretch_interval.items.unit
                "
                (minValueChange)="
                  optimizationValue.hexagonal_grid.vertical_stretch_interval[0] =
                    $event
                "
                (maxValueChange)="
                  optimizationValue.hexagonal_grid.vertical_stretch_interval[1] =
                    $event
                "
              ></energy-platform-ranged-slider>
            </div>
          </ng-container>

          <ng-container *ngIf="honeycombGrid.checked">
            <div class="grid-item sub-header">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.honeycombGrid' | translate }}
                </h2>
              </div>
            </div>
            <!-- 
              Expansion Interval 
            -->
            <div class="grid-item expansion-interval">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.expansionInterval' | translate }}
                </h2>
                <!-- <mat-icon
                [matTooltip]="
                  schema.optimization.properties.honeycomb_grid?.properties?.expansion_interval?.description
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon> -->
              </div>
              <energy-platform-ranged-slider
                *ngIf="schema.optimization"
                #expnasionInterval
                [min]="
                  schema.optimization.properties.honeycomb_grid.properties
                    .expansion_interval.items.minimum
                "
                [max]="
                  schema.optimization.properties.honeycomb_grid.properties
                    .expansion_interval.items.maximum
                "
                [step]="
                  schema.optimization.properties.honeycomb_grid.properties
                    .expansion_interval.items.step
                "
                [unit]="
                  schema.optimization.properties.honeycomb_grid.properties
                    .expansion_interval.items.unit
                "
                (minValueChange)="
                  optimizationValue.honeycomb_grid.expansion_interval[0] =
                    $event
                "
                (maxValueChange)="
                  optimizationValue.honeycomb_grid.expansion_interval[1] =
                    $event
                "
              ></energy-platform-ranged-slider>
            </div>
          </ng-container>

          <ng-container *ngIf="slantedGrid.checked">
            <div class="grid-item sub-header">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.slantedGrid' | translate }}
                </h2>
              </div>
            </div>
            <!-- 
              Shearing Angle Interval 
            -->
            <div class="grid-item shearing-angle-interval">
              <div class="title">
                <h2>
                  {{
                    'parameter.optimization.shearingAngleInterval' | translate
                  }}
                </h2>
                <!-- <mat-icon
                [matTooltip]="
                  schema.optimization.properties.slanted_grid?.properties?.shearing_angle_interval?.description
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon> -->
              </div>
              <energy-platform-ranged-slider
                *ngIf="schema.optimization"
                #shearingAngleInterval
                [min]="
                  schema.optimization.properties.slanted_grid.properties
                    .shearing_angle_interval.items.minimum
                "
                [max]="
                  schema.optimization.properties.slanted_grid.properties
                    .shearing_angle_interval.items.maximum
                "
                [step]="
                  schema.optimization.properties.slanted_grid.properties
                    .shearing_angle_interval.items.step
                "
                [unit]="
                  schema.optimization.properties.slanted_grid.properties
                    .shearing_angle_interval.items.unit
                "
                (minValueChange)="
                  optimizationValue.slanted_grid.shearing_angle_interval[0] =
                    $event
                "
                (maxValueChange)="
                  optimizationValue.slanted_grid.shearing_angle_interval[1] =
                    $event
                "
              ></energy-platform-ranged-slider>
            </div>
            <!-- 
              Rows Distance Interval 
            -->
            <div class="grid-item rows-distance-interval">
              <div class="title">
                <h2>
                  {{
                    'parameter.optimization.rowsDistanceInterval' | translate
                  }}
                </h2>
                <!-- <mat-icon
                  [matTooltip]="
                    schema.optimization.properties.slanted_grid?.properties?.rows_distance_interval?.description
                  "
                  matTooltipPosition="right"
                >
                info_outlined
                </mat-icon> -->
              </div>
              <energy-platform-ranged-slider
                *ngIf="schema.optimization"
                #rowsDistanceInterval
                [min]="
                  schema.optimization.properties.slanted_grid.properties
                    .rows_distance_interval.items.minimum
                "
                [max]="
                  schema.optimization.properties.slanted_grid.properties
                    .rows_distance_interval.items.maximum
                "
                [step]="
                  schema.optimization.properties.slanted_grid.properties
                    .rows_distance_interval.items.step
                "
                [unit]="
                  schema.optimization.properties.slanted_grid.properties
                    .rows_distance_interval.items.unit
                "
                (minValueChange)="
                  optimizationValue.slanted_grid.rows_distance_interval[0] =
                    $event
                "
                (maxValueChange)="
                  optimizationValue.slanted_grid.rows_distance_interval[1] =
                    $event
                "
              ></energy-platform-ranged-slider>
            </div>
            <!-- 
              Columns Distance Interval 
            -->
            <div class="grid-item columns-distance-interval">
              <div class="title">
                <h2>
                  {{
                    'parameter.optimization.colsDistanceInterval' | translate
                  }}
                </h2>
                <!-- <mat-icon
                [matTooltip]="
                  schema.optimization.properties.slanted_grid?.properties?.cols_distance_interval?.description
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon> -->
              </div>
              <energy-platform-ranged-slider
                *ngIf="schema.optimization"
                #colsDistanceInterval
                [min]="
                  schema.optimization.properties.slanted_grid.properties
                    .cols_distance_interval.items.minimum
                "
                [max]="
                  schema.optimization.properties.slanted_grid.properties
                    .cols_distance_interval.items.maximum
                "
                [step]="
                  schema.optimization.properties.slanted_grid.properties
                    .cols_distance_interval.items.step
                "
                [unit]="
                  schema.optimization.properties.slanted_grid.properties
                    .cols_distance_interval.items.unit
                "
                (minValueChange)="
                  optimizationValue.slanted_grid.cols_distance_interval[0] =
                    $event
                "
                (maxValueChange)="
                  optimizationValue.slanted_grid.cols_distance_interval[1] =
                    $event
                "
              ></energy-platform-ranged-slider>
            </div>
          </ng-container>

          <ng-container *ngIf="spiralGrid.checked">
            <div class="grid-item sub-header">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.spiralGrid' | translate }}
                </h2>
              </div>
            </div>
            <!-- 
              Density Interval 
            -->
            <div class="grid-item density-interval">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.densityInterval' | translate }}
                </h2>
                <!-- <mat-icon
                  [matTooltip]="
                    schema.optimization.properties.spiral_grid?.properties?.density_interval?.description
                  "
                  matTooltipPosition="right"
                >
                info_outlined
                </mat-icon> -->
              </div>
              <energy-platform-ranged-slider
                *ngIf="schema.optimization"
                #densityInterval
                [min]="
                  schema.optimization.properties.spiral_grid.properties
                    .density_interval.items.minimum
                "
                [max]="
                  schema.optimization.properties.spiral_grid.properties
                    .density_interval.items.maximum
                "
                [step]="
                  schema.optimization.properties.spiral_grid.properties
                    .density_interval.items.step
                "
                [unit]="
                  schema.optimization.properties.spiral_grid.properties
                    .density_interval.items.unit
                "
                (minValueChange)="
                  optimizationValue.spiral_grid.density_interval[0] = $event
                "
                (maxValueChange)="
                  optimizationValue.spiral_grid.density_interval[1] = $event
                "
              ></energy-platform-ranged-slider>
            </div>
            <!-- 
              Relative Zoom Interval 
            -->
            <div class="grid-item relative-zoom-interval">
              <div class="title">
                <h2>
                  {{
                    'parameter.optimization.relativeZoomInterval' | translate
                  }}
                </h2>
                <!-- <mat-icon
                [matTooltip]="
                  schema.optimization.properties.spiral_grid?.properties?.relative_zoom_interval?.description
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon> -->
              </div>
              <energy-platform-ranged-slider
                *ngIf="schema.optimization"
                #relativeZoomInterval
                [min]="
                  schema.optimization.properties.spiral_grid.properties
                    .relative_zoom_interval.items.minimum
                "
                [max]="
                  schema.optimization.properties.spiral_grid.properties
                    .relative_zoom_interval.items.maximum
                "
                [step]="
                  schema.optimization.properties.spiral_grid.properties
                    .relative_zoom_interval.items.step
                "
                [unit]="
                  schema.optimization.properties.spiral_grid.properties
                    .relative_zoom_interval.items.unit
                "
                (minValueChange)="
                  optimizationValue.spiral_grid.relative_zoom_interval[0] =
                    $event
                "
                (maxValueChange)="
                  optimizationValue.spiral_grid.relative_zoom_interval[1] =
                    $event
                "
              ></energy-platform-ranged-slider>
            </div>
            <!-- 
              Vertical Stretch Interval 
            -->
            <div class="grid-item vertical-stretch-interval">
              <div class="title">
                <h2>
                  {{
                    'parameter.optimization.verticalStretchInterval' | translate
                  }}
                </h2>
                <!-- <mat-icon
                [matTooltip]="
                  schema.optimization.properties.spiral_grid?.properties?.vertical_stretch_interval?.description
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon> -->
              </div>
              <energy-platform-ranged-slider
                *ngIf="schema.optimization"
                #verticalStretchInterval
                [min]="
                  schema.optimization.properties.spiral_grid.properties
                    .vertical_stretch_interval.items.minimum
                "
                [max]="
                  schema.optimization.properties.spiral_grid.properties
                    .vertical_stretch_interval.items.maximum
                "
                [step]="
                  schema.optimization.properties.spiral_grid.properties
                    .vertical_stretch_interval.items.step
                "
                [unit]="
                  schema.optimization.properties.spiral_grid.properties
                    .vertical_stretch_interval.items.unit
                "
                (minValueChange)="
                  optimizationValue.spiral_grid.vertical_stretch_interval[0] =
                    $event
                "
                (maxValueChange)="
                  optimizationValue.spiral_grid.vertical_stretch_interval[1] =
                    $event
                "
              ></energy-platform-ranged-slider>
            </div>
          </ng-container>

          <ng-container *ngIf="localSearch.checked">
            <div class="grid-item sub-header">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.localSearch' | translate }}
                </h2>
              </div>
            </div>
            <!-- 
              Circle Number 
            -->
            <div class="grid-item circle-number">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.numCircles' | translate }}
                </h2>
                <!-- <mat-icon
                [matTooltip]="
                  schema.optimization.properties.local_search?.properties?.num_circles?.description
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon> -->
              </div>
              <energy-platform-parameter-slider
                #numCircles
                [min]="
                  schema.optimization.properties.local_search.properties
                    .num_circles.minimum
                "
                [max]="
                  schema.optimization.properties.local_search.properties
                    .num_circles.maximum
                "
                [step]="
                  schema.optimization.properties.local_search.properties
                    .num_circles.step
                "
                [unit]="
                  schema.optimization.properties.local_search.properties
                    .num_circles.unit
                "
                [value]="optimizationValue.local_search.num_circles"
                (valueChange)="
                  optimizationValue.local_search.num_circles = $event
                "
              ></energy-platform-parameter-slider>
            </div>
            <!-- 
              Circle Positions Number 
            -->
            <div class="grid-item circle-positions-number">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.numCirclePositions' | translate }}
                </h2>
                <!-- <mat-icon
                [matTooltip]="
                  schema.optimization.properties.local_search?.properties?.num_circle_positions?.description
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon> -->
              </div>
              <energy-platform-parameter-slider
                #numCirclePositions
                [min]="
                  schema.optimization.properties.local_search.properties
                    .num_circle_positions.minimum
                "
                [max]="
                  schema.optimization.properties.local_search.properties
                    .num_circle_positions.maximum
                "
                [step]="
                  schema.optimization.properties.local_search.properties
                    .num_circle_positions.step
                "
                [unit]="
                  schema.optimization.properties.local_search.properties
                    .num_circle_positions.unit
                "
              ></energy-platform-parameter-slider>
            </div>
            <!-- 
              Radial Distance 
            -->
            <div class="grid-item radial-distance">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.radialDistance' | translate }}
                </h2>
                <!-- <mat-icon
                [matTooltip]="
                  schema.optimization.properties.local_search?.properties?.radial_distance?.description
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon> -->
              </div>
              <energy-platform-parameter-slider
                #radialDistance
                [min]="
                  schema.optimization.properties.local_search.properties
                    .radial_distance.minimum
                "
                [max]="
                  schema.optimization.properties.local_search.properties
                    .radial_distance.maximum
                "
                [step]="
                  schema.optimization.properties.local_search.properties
                    .radial_distance.step
                "
                [unit]="
                  schema.optimization.properties.local_search.properties
                    .radial_distance.unit
                "
                [value]="optimizationValue.local_search.radial_distance"
                (valueChange)="
                  optimizationValue.local_search.radial_distance = $event
                "
              ></energy-platform-parameter-slider>
            </div>
            <!-- 
              Iteration Range 
            -->
            <div class="grid-item iteration-range">
              <div class="title">
                <h2>
                  {{ 'parameter.optimization.iterationRange' | translate }}
                </h2>
                <!-- <mat-icon
                [matTooltip]="
                  schema.optimization.properties.local_search?.properties?.iteration_range?.description
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon> -->
              </div>
              <energy-platform-ranged-slider
                *ngIf="schema.optimization"
                #iterationRange
                [min]="
                  schema.optimization.properties.local_search.properties
                    .iteration_range.items.minimum
                "
                [max]="
                  schema.optimization.properties.local_search.properties
                    .iteration_range.items.maximum
                "
                [step]="
                  schema.optimization.properties.local_search.properties
                    .iteration_range.items.step
                "
                [unit]="
                  schema.optimization.properties.local_search.properties
                    .iteration_range.items.unit
                "
                (minValueChange)="
                  optimizationValue.local_search.iteration_range[0] = $event
                "
                (maxValueChange)="
                  optimizationValue.local_search.iteration_range[1] = $event
                "
              ></energy-platform-ranged-slider>
            </div>
            <!-- 
              Termination Relative Convergence 
            -->
            <div class="grid-item termination-relative-convergence">
              <div class="title">
                <h2>
                  {{
                    'parameter.optimization.terminationRelativeConvergence'
                      | translate
                  }}
                </h2>
                <!-- <mat-icon
                [matTooltip]="
                  schema.optimization.properties.local_search?.properties?.termination_relative_convergence?.description
                "
                matTooltipPosition="right"
              >
                info_outlined
              </mat-icon> -->
              </div>
              <energy-platform-parameter-slider
                #terminationRelativeConvergence
                [min]="
                  schema.optimization.properties.local_search.properties
                    .termination_relative_convergence.minimum
                "
                [max]="
                  schema.optimization.properties.local_search.properties
                    .termination_relative_convergence.maximum
                "
                [step]="
                  schema.optimization.properties.local_search.properties
                    .termination_relative_convergence.step
                "
                [unit]="
                  schema.optimization.properties.local_search.properties
                    .termination_relative_convergence.unit
                "
                [value]="
                  optimizationValue.local_search
                    .termination_relative_convergence
                "
                (valueChange)="
                  optimizationValue.local_search.termination_relative_convergence =
                    $event
                "
              ></energy-platform-parameter-slider>
            </div>
          </ng-container>
        </ng-container>
      </div>

      <!--
        Save Button
      -->
      <button
        *ngIf="combinatorial.checked"
        mat-button
        class="pill-button save-button"
        [disabled]="!buttonValidator([])"
        (click)="onSave()"
      >
        {{ 'parameter.general.save' | translate }}
      </button>
    </div>
    <div class="right-container">
      <div class="grid">
        <!--
          Optimization Methods
        -->
        <div class="grid-item optimization-methods">
          <div class="title">
            <h2>{{ 'parameter.optimization.opSteps' | translate }}</h2>
            <!-- <mat-icon
              [matTooltip]="
                schema.optimization.properties.multi_step?.properties?.description
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon> -->
          </div>
          <mat-radio-group
            class="radio-container"
            disableOptionCentering
            (change)="
              optimizationValue.optimization_mode = $event.value;
              optimizationValue.multi_step.optimization_steps[0] = $event.value
            "
          >
            <mat-radio-button #closePacking value="close_packing">
              {{ 'parameter.optimization.closePacking' | translate }}
            </mat-radio-button>
            <mat-radio-button #hexagonalGrid value="hexagonal_grid">
              {{ 'parameter.optimization.hexagonalGrid' | translate }}
            </mat-radio-button>
            <mat-radio-button #spiralGrid value="spiral_grid">
              {{ 'parameter.optimization.spiralGrid' | translate }}
            </mat-radio-button>
            <mat-radio-button #slantedGrid value="slanted_grid">
              {{ 'parameter.optimization.slantedGrid' | translate }}
            </mat-radio-button>
            <mat-radio-button #honeycombGrid value="honeycomb_grid">
              {{ 'parameter.optimization.honeycombGrid' | translate }}
            </mat-radio-button>
          </mat-radio-group>
          <mat-divider></mat-divider>
          <mat-checkbox
            #localSearch
            (change)="
              localSearch.checked
                ? (optimizationValue.multi_step.optimization_steps[1] =
                    'local_search')
                : optimizationValue.multi_step.optimization_steps.pop()
            "
            >{{ 'parameter.optimization.useLocalSearch' | translate }}
          </mat-checkbox>
        </div>
        <!--

        -->
        <div class="grid-item">
          <div class="title">
            <h2>
              {{ 'parameter.optimization.patternSearchMethod' | translate }}
            </h2>
            <!-- <mat-icon
              [matTooltip]="schema.optimization.properties.multi_step?.properties?.pattern_search_method?.description"
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon> -->
          </div>
          <mat-radio-group
            class="radio-container"
            disableOptionCentering
            (change)="
              optimizationValue.multi_step.pattern_search_method = $event.value
            "
          >
            <mat-radio-button #downhillSimplex value="downhill_simplex">
              {{ 'parameter.optimization.downhillSimplex' | translate }}
            </mat-radio-button>
            <mat-radio-button
              #combinatorial
              value="combinatorial"
              checked="true"
            >
              {{ 'parameter.optimization.combinatorial' | translate }}
            </mat-radio-button>
          </mat-radio-group>
        </div>
      </div>
    </div>
  </div>
</div>
